﻿Imports System.Text

Namespace ManagerApplication
	''' <summary>
	''' Interaction logic for MainWindow.xaml
	''' </summary>
	Partial Public Class MainWindow
		Inherits Window
		Public Sub New()
			InitializeComponent()
		End Sub

		Private Sub GetPendingExpenseReports()
			Dim proxy As New PendingExpenseReportServiceReference.ServiceClient()
			Dim expenses = proxy.GetPendingExpenseReports()

			ExpensesDataGrid.ItemsSource = expenses
		End Sub

		Private Sub Window_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
			GetPendingExpenseReports()
		End Sub

		Private Sub RefreshButton_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			GetPendingExpenseReports()
		End Sub

		Private Sub ApproveButton_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			ApproveExpenseReport(True, String.Format("Expense report {0} was approved", IdTextBox.Text))
		End Sub

		Private Sub ApproveExpenseReport(ByVal expenseReportApproved As Boolean, ByVal displayMessage As String)
			Dim expenseReportId As Integer
			If Integer.TryParse(IdTextBox.Text, expenseReportId) Then
				SendApprovalMessage(expenseReportId, expenseReportApproved)
				MessageBox.Show(displayMessage)
				GetPendingExpenseReports()
			End If
		End Sub

		Private Sub SendApprovalMessage(ByVal expenseReportId As Integer, ByVal expenseReportApproved As Boolean)
			Dim proxy As New ExpenseReportServiceReference.ServiceClient()
			proxy.ApproveExpense(expenseReportId, expenseReportApproved)
		End Sub

		Private Sub DenyButton_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			ApproveExpenseReport(False, String.Format("Expense report {0} was denied", IdTextBox.Text))
		End Sub
	End Class
End Namespace